plats = {}
units = {}
grabs = {}

function init(playerid,dataid)
	player = mmf.newObject(playerid)
	data = mmf.newObject(dataid)
end

function addunit(unitid)
	local id = #units + 1
	
	units[id] = mmf.newObject(unitid)
	local unit = units[id]
	
	unit.deltax = 0
	unit.deltay = 0
	unit.oldx = 0
	unit.oldy = 0
end

function addgrab(grabid)
	local id = #grabs + 1
	
	grabs[id] = mmf.newObject(grabid)
end

function addplat(platid)
	local id = #plats + 1
	
	plats[id] = mmf.newObject(platid)
	
	local plat = plats[id]
	plat.data = {}
end

function loop()
	for id,plat in ipairs(plats) do
		if (plat.values[OWNER] > 0) then
			local owner = mmf.newObject(plat.values[OWNER])
			
			plat.values[XPOS] = owner.values[XPOS] + plat.values[XOFFSET]
			plat.values[YPOS] = owner.values[YPOS] + plat.values[YOFFSET]
			plat.x = plat.values[XPOS]
			plat.y = plat.values[YPOS]
		end
	end
	
	for id,unit in ipairs(units) do
		unit.animFrame = 2
		local x1 = unit.xLeft
		local x2 = unit.xRight
		local y1 = unit.yTop
		local y2 = unit.yBottom
		
		unit.deltax = unit.values[XPOS] - unit.oldx
		unit.deltay = unit.values[YPOS] - unit.oldy
		unit.oldx = unit.values[XPOS]
		unit.oldy = unit.values[YPOS]
		
		if (unit.flags[9] == false) then
			for i,plat in ipairs(plats) do
				local a1 = plat.xLeft
				local a2 = plat.xRight
				local b1 = plat.yTop
				local b2 = plat.yBottom
				
				local r = a1 - x2
				local u = y1 - b2
				local l = x1 - a2
				local d = b1 - y2
				
				local plata = plat.data
				local pid = unit.fixed
				
				local dr,du,dl,dd = 0,0,0,0
				
				if (plata[pid] == nil) then
					plata[pid] = {}
					local ugh = plata[pid]
					
					ugh.r = r
					ugh.u = u
					ugh.l = l
					ugh.d = d
				else
					local ugh = plata[pid]
					dr = ugh.r
					du = ugh.u
					dl = ugh.l
					dd = ugh.d
				end
			
				if (r < 0) and (u < 0) and (l < 0) and (d < 0) then
					if (r < 0) and (dr >= 0) then
						unit.x = unit.x - math.abs(r)
						unit.values[XPOS] = unit.x
						unit.values[XVEL] = math.min(unit.values[XVEL], 0)
						unit.flags[RIGHT] = true
						r = 1
					end
					
					if (u < 0) and (du >= 0) then
						unit.y = unit.y + math.abs(u)
						unit.values[YPOS] = unit.y
						unit.values[YVEL] = math.max(unit.values[YVEL], 0)
						unit.flags[TOP] = true
						u = 1
					end
					
					if (l < 0) and (dl >= 0) then
						unit.x = unit.x + math.abs(l)
						unit.values[XPOS] = unit.x
						unit.values[XVEL] = math.max(unit.values[XVEL], 0)
						unit.flags[LEFT] = true
						l = 1
					end
					
					if (d < 0) and (dd >= 0) then
						unit.y = unit.y - math.abs(d)
						unit.values[YPOS] = unit.y
						unit.values[YVEL] = math.min(unit.values[YVEL], 0)
						unit.flags[BOTTOM] = true
						unit.values[XPOS] = unit.values[XPOS] + plat.values[XVEL] * 0.2
						d = 1
					end
				end
				
				local ugh = plata[pid]
				ugh.r = r
				ugh.u = u
				ugh.l = l
				ugh.d = d
			end
			
			if (unit.values[GRAB] > 0) then
				local surface = mmf.newObject(unit.values[GRAB])
				
				unit.values[XPOS] = surface.values[XPOS] + math.cos(unit.grabdir + math.rad(surface.values[ANGLE])) * unit.grabdist
				unit.values[YPOS] = surface.values[YPOS] - math.sin(unit.grabdir + math.rad(surface.values[ANGLE])) * unit.grabdist
				unit.values[XVEL] = unit.values[XVEL] * 0.5
				unit.values[YVEL] = unit.values[YVEL] * 0.5
				
				a1 = surface.xLeft
				a2 = surface.xRight
				b1 = surface.yTop
				b2 = surface.yBottom
				
				local middlex = a1 + (a2 - a1) * 0.5
				local middley = b1 + (b2 - b1) * 0.5
				
				local dist = math.sqrt((middley - unit.values[YPOS]) ^ 2 + (middlex - unit.values[XPOS]) ^ 2)
				local dir = 0-math.atan2(unit.values[YPOS] - middley, unit.values[XPOS] - middlex) - math.rad(surface.values[ANGLE])
				
				local h = math.abs(math.cos(dir) * dist) - surface.values[WIDTH] * 0.5
				local v = math.abs(math.sin(dir) * dist) - surface.values[HEIGHT] * 0.5
				
				if (h >= 0) or (v >= 0) or (surface.flags[8] == true) then
					local newone = grabcheck(unit.fixed)
					
					if (newone == 0) then
						unit.values[GRAB] = 0
						unit.values[XVEL] = unit.deltax * 5
						unit.values[YVEL] = unit.deltay * 5
					end
				end
			end
		end
	end
end

function climbjump(unitid,strength)
	local unit = mmf.newObject(unitid)
	local grab = mmf.newObject(unit.values[GRAB])
	
	local xvel = grab.values[XVEL]
	local yvel = grab.values[YVEL]
	
	if (math.abs(xvel) < math.abs(unit.deltax * 5)) then
		xvel = unit.deltax * 5
	end
	
	if (math.abs(yvel) < math.abs(unit.deltay * 5)) and (unit.deltay < yvel) then
		yvel = unit.deltay * 5
	end
	
	xvel = xvel + unit.values[XVEL] * 2
	yvel = yvel + unit.values[YVEL] * 0.5
	
	if (strength < 0) and (yvel > 0) then
		yvel = 0
	end
	
	if (math.abs(grab.values[YVEL]) + math.abs(grab.values[XVEL]) > 5) and (strength < 0) then
		strength = strength * 1.2
		print("uh")
	end
	
	unit.values[GRAB] = 0
	unit.values[XVEL] = xvel
	unit.values[YVEL] = strength + yvel
	
	MF_alert(strength + yvel)
end

function grabloop()
	for id,unit in ipairs(units) do
		if (unit.values[GRAB] > 0) then
			local surface = mmf.newObject(unit.values[GRAB])
			
			unit.grabdist = math.sqrt((surface.values[YPOS] - unit.values[YPOS]) ^ 2 + (surface.values[XPOS] - unit.values[XPOS]) ^ 2)
			unit.grabdir = 0-math.atan2(unit.values[YPOS] - surface.values[YPOS], unit.values[XPOS] - surface.values[XPOS]) - math.rad(surface.values[ANGLE])
		end
	end
end

function grabcheck(unitid)
	local unit = mmf.newObject(unitid)
	local success = 0
	local x1 = unit.xLeft
	local x2 = unit.xRight
	local y1 = unit.yTop
	local y2 = unit.yBottom
	
	for id,grab in ipairs(grabs) do
		local a1 = grab.xLeft
		local a2 = grab.xRight
		local b1 = grab.yTop
		local b2 = grab.yBottom
		
		local middlex = a1 + (a2 - a1) * 0.5
		local middley = b1 + (b2 - b1) * 0.5
		
		local dist = math.sqrt((middley - unit.values[YPOS]) ^ 2 + (middlex - unit.values[XPOS]) ^ 2)
		local dir = 0-math.atan2(unit.values[YPOS] - middley, unit.values[XPOS] - middlex) - math.rad(grab.values[ANGLE])
		
		local h = math.abs(math.cos(dir) * dist) - grab.values[WIDTH] * 0.5
		local v = math.abs(math.sin(dir) * dist) - grab.values[HEIGHT] * 0.5
		
		if (h < 0) and (v < 0) and (grab.flags[8] == false) then
			unit.values[GRAB] = grab.fixed
			unit.values[DISABLE] = 0
			success = 1
			
			data.values[DELAY] = 5
			
			unit.grabdist = math.sqrt((grab.values[YPOS] - unit.values[YPOS]) ^ 2 + (grab.values[XPOS] - unit.values[XPOS]) ^ 2)
			unit.grabdir = 0-math.atan2(unit.values[YPOS] - grab.values[YPOS], unit.values[XPOS] - grab.values[XPOS]) - math.rad(grab.values[ANGLE])
		end
	end
	
	return success
end

function weakpoint(id,bossid)
	local boss = mmf.newObject(bossid)
	
	if (id == 1) then
		boss.values[8] = 2
		boss.values[9] = 0
		boss.values[10] = 0
	elseif (id == 2) then
		boss.values[8] = 3
		boss.values[9] = 0
		boss.values[10] = 0
	elseif (id == 3) then
		boss.values[8] = 4
		boss.values[9] = 0
		boss.values[10] = 0
	end
end

function removeplat(platid)
	for id,plat in ipairs(plats) do
		if (plat.fixed == platid) then
			plat = {}
			table.remove(plats, id)
			
			MF_destroy(platid)
		end
	end
end

function removegrab(grabid)
	for id,grab in ipairs(grabs) do
		if (grab.fixed == grabid) then
			grab = {}
			table.remove(grabs, id)
			
			MF_destroy(grabid)
		end
	end
end